import 
{
	select,
  selectAll,
  scaleOrdinal,
  json,
} 
from 'd3';


	//.call(d3.zoom().on('zoom',(event)=>{
  //  node.attr('transform',event.transform);
  //  link.attr('transform',event.transform)}))

const colorScale=['red','lightgreen','blue','gold','orange','aqua']

//effect
//svg.attr('preserveAspectRatio','xMidYMid meet')
//		.attr('viewBox',[0,0,width*2,height*2]);

 //appending little triangles, path object, as arrowhead
//The <defs> element is used to store graphical objects that will be used at a later time
//The <marker> element defines the graphic that is to be used for drawing arrowheads or polymarkers on a given <path>, <line>, <polyline> or <polygon> element.


json('data.json').then(data=>{
	
  const svg=select('svg')
  const width=+svg.attr('width')
	const height=+svg.attr('height')
  const centre_x=width/2
	const centre_y=height/2
	const container=svg.append('g').attr('class','container')
  
  container.append('defs').append('marker')
    .attr("id",'arrowhead')
    .attr('viewBox','-0 -5 10 10') //the bound of the SVG viewport for the current SVG fragment. defines a coordinate system 10 wide and 10 high starting on (0,-5)
     .attr('refX',36) // x coordinate for the reference point of the marker. If circle is bigger, this need to be bigger.
     .attr('refY',0)
     .attr('orient','auto')
        .attr('markerWidth',6)
        .attr('markerHeight',6)
        .attr('xoverflow','visible')
    .append('svg:path')
    .attr('d', 'M 0,-5 L 10 ,0 L 0,5')
    .attr('fill', '#999')
    .style('stroke','none');
  
  var zoomF=d3.zoom()
              .scaleExtent([1/4,8])
              .on('zoom',(event)=>{
                container.attr('transform',event.transform)});

	svg.call(zoomF)
  
	const links=data.links.map(d=>Object.create(d))//make links an empty array with the some form as links 
  // get only some of the items needed from links
 
  links.forEach((d,i)=>{
    d.srcType=data.links[i].srcType
    d.tgtType=data.links[i].tgtType
    d.relationship=data.links[i].relationship
    d.value=data.links[i].value
  })
  
  const nodes=data.nodes.map(d=>Object.create(d))
  nodes.forEach((d,i)=>{
    d.group=data.nodes[i].group
  })
  
  const simulation=d3.forceSimulation(nodes)
  	.force('link',d3.forceLink(links)
           .id(d=>d.id)
           .distance(300))
  	.force('charge',d3.forceManyBody()//charge force,
           	.strength(-1500)
            .distanceMin(100)
           	.distanceMax(350))
  	.force('collision',d3.forceCollide()//collision force, prevent the overlapping
           	.radius(70).iterations(2)
           )
  	.force('center',d3.forceCenter(width/2,height/2))
  
	console.log(links)
  console.log(nodes)
  console.log(data)
  
  // about the drag movement
  const drag=simulation=>{
    function dragstarted(event){
      if (!event.active) simulation.alphaTarget(0.5).restart();
      event.subject.fx=event.subject.x;
      event.subject.fy=event.subject.y;
    }
    function dragged(event) {
      event.subject.fx=event.x;
      event.subject.fy=event.y;
    }
    function dragended(event){
      if(!event.active) simulation.alphaTarget(0);
      event.subject.fx=null;
      event.subject.fy=null;
    }
    return d3.drag()
    	.on('start',dragstarted)
    	.on('drag',dragged)
    	.on('end',dragended)
  }
  
  const link=container.append('g')
  	.attr('class','link')
  	.selectAll('line')
  		.data(links)
  		.enter()  //.join('line')==.enter().append('line')
  		.append('line')//path or line
  			.attr('id',(d,i)=>'link'+i)
  			.attr('marker-end','url(#arrowhead)')
  				//make path go along with the link provide position for link label
  
  const linkPath=container.append('g')
  			.attr('class','linkpath')
  			.selectAll('path')
  				.data(links)
  				.enter()  //.join('line')==.enter().append('line')
  				.append('path')//path or line
  			.attr('stroke','black')
  			.attr('stroke-width','2px')
        .attr('fill-opacity', 0)
        .attr('stroke-opacity', 0)
        .attr('id', function (d, i) {return 'linkId_' + i})
        .style('pointer-events', 'none');
  
  const linkLabel=container.append('g')
  			.attr('class','linklabel')
  			.selectAll('.linka')
  			.attr('class','linklabel')
  			.data(links)
  			.enter()
        .append('text')
  			.style('pointer-events','none')
  			.attr('id',(d,i)=>{'linklabel_'+i})
        .attr('dx',0)
        .attr('dy','1.35em')
        .style('fill','black')
         
  
  //To render text along the shape of a <path>, enclose the text in a <textPath> element that has an href attribute with a reference to the <path> element.
    linkLabel.append('textPath')
  		.attr('xlink:href', function (d, i) {return '#linkId_' + i})
      .style("text-anchor", "middle")
      .style("pointer-events", "none")
      .attr("startOffset", "50%")
      .text(d => d.relationship)

   const node=container.append('g')
  	.attr('class','node')
   	.selectAll('g')
   		.data(nodes)
   		.enter()
   		.append('g')
  			//.attr('transform',`translate(${+centre_x},${+centre_y})`)
   
   const circle=node
   		.append('circle')
   		.attr('r',50)
   		.attr('fill',d=>colorScale[d.group])
    
   //how about circle? the same effect as node
		node
   	.on('mouseover',focusNode)
   	.on('mouseout',blurNode)
  	.on('dblclick',d=>{
      //console.log('open tab')
      // add listener to open url assign by d
      window.open(
        'http://www.google.com',
        '_blank')
        })
  
   	.call(drag(simulation))
   	
   const nodeLb1=node
   			.append('text')
   			.attr('dy','0.3em')
  			.style('fill','#555')
   			.text(d=>d.id)
   			
   			//add hypertext link
   			
   			
   
   //at first there is node d.source.x, where to get it?
   simulation.on('tick',()=>{
     link
     	.attr('x1',d=>d.source.x)
     	.attr('y1',d=>d.source.y)
     	.attr('x2',d=>d.target.x)
     	.attr('y2',d=>d.target.y)
     
     node
     	.attr("transform",d=>"translate("+d.x+","+d.y+")")
     
     linkPath
       .attr('d', d => 'M ' + d.source.x + ' ' + d.source.y + ' L ' + d.target.x + ' ' + d.target.y)
     		.attr('transform',function(d){
       			if (d.target.x<d.source.x){
        //        var bbox=this.getBBox()
       	//				rx=bbox.x+bbox.width/2
       	//				ry=bbox.y+bbox.height/2
       					return 'rotate(180)'
     					}
           else{
              	return 'rotate(0)'
              }
                 })
     
     	//.attr("transform",d=>"translate("+d.x+","+d.y+")")
     //linkLabel
       //.attr('d', d => 'M ' + d.source.x + ' ' + d.source.y + ' L ' + d.target.x + ' ' + d.target.y);
				//.attr('transform',function(d){
       	//		if (d.target.x<d.source.x){
        //        var bbox=this.getBBox()
       	//				rx=bbox.x+bbox.width/2
       	//				ry=bbox.y+bbox.height/2
       	//				return 'rotate(180' + rx+' '+ry+')'
     		//			}
        //   else{
        //      	return 'rotate(0)'
        //      }
        //         })
   })
  
   function focusNode(){
     select(this).classed('nodeHover',true)
   }
   
  	function blurNode(){
      select(this).classed('nodeHover',false)
    }
  	
      //add zoom func
  	//const zoom = d3.zoom()
    //  .scaleExtent([1/2, 64])
    //  .on("zoom", zoomed);
  
  	//const zoomRect = svg.append("rect")
    //  .attr("width", width)
     // .attr("height", height)
      //.style("fill", "none")
      //.style("pointer-events", "all")
		
    //zoomRect.call(zoom)
    //.call(zoom.translateTo, 0, 0);
  
    //function zoomed(event) {
      //transform = event.transform;
      //node.attr("transform", event.transform);
      //link.attr("transform", event.transform);
    //}
  
 

})


